## libnova 0.16

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6 FATAL_ERROR)

project(libnova)

# define the name of the library
set(LIBRARY_NAME libnova)

option(BUILD_SHARED_LIBRARY "Set to ON to build libnova as a shared library." ON)
if(BUILD_SHARED_LIBRARY)
    set(BUILD_SHARED_LIBS TRUE)
    add_definitions(-DLIBNOVA_SHARED)
else(BUILD_SHARED_LIBRARY)
    set(BUILD_SHARED_LIBS FALSE)
    add_definitions(-DLIBNOVA_STATIC)
endif(BUILD_SHARED_LIBRARY)

# add some definitions
if(WIN32)
    add_definitions(-D_USE_MATH_DEFINES)
    add_definitions(-D_SCL_SECURE_NO_WARNINGS)
    add_definitions(-D_CRT_SECURE_NO_DEPRECATE)
    add_definitions(-D__WIN32__)
endif(WIN32)

# add more optimization flags to the visual studio release compilation
if(MSVC)
    set(CMAKE_CXX_FLAGS_RELEASE "/MD /Ox /Ob2 /D NDEBUG")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /arch:SSE2 /GS-")
endif(MSVC)


# set the debug postfix
set(CMAKE_DEBUG_POSTFIX "d" CACHE STRING "add a postfix, usually d on windows")

# set LIB_POSTFIX
if(UNIX AND NOT WIN32 AND NOT APPLE)
  if(CMAKE_SIZEOF_VOID_P MATCHES "8")
      set(LIB_POSTFIX "64" CACHE STRING "suffix for 32/64 dir placement")
      mark_as_advanced(LIB_POSTFIX)
  endif(CMAKE_SIZEOF_VOID_P MATCHES "8")
endif(UNIX AND NOT WIN32 AND NOT APPLE)
if(NOT DEFINED LIB_POSTFIX)
    set(LIB_POSTFIX "")
endif(NOT DEFINED LIB_POSTFIX)


# set and create the EXECUTABLE_OUTPUT_PATH
set(EXECUTABLE_OUTPUT_PATH ${PROJECT_BINARY_DIR}/bin)
file(MAKE_DIRECTORY ${EXECUTABLE_OUTPUT_PATH})

# set and create the LIBRARY_OUTPUT_PATH
set(LIBRARY_OUTPUT_PATH ${PROJECT_BINARY_DIR}/lib)
file(MAKE_DIRECTORY ${LIBRARY_OUTPUT_PATH})


# define a macro to setup executable program which are linked with libnova
macro(SETUP_EXECUTABLE EXECUTABLE_NAME)
    add_executable(${EXECUTABLE_NAME} ${EXECUTABLE_NAME}.c)
    target_link_libraries(${EXECUTABLE_NAME} libnova)
    set_target_properties(${EXECUTABLE_NAME} PROPERTIES DEBUG_POSTFIX "${CMAKE_DEBUG_POSTFIX}")
    if(MSVC)
        set_target_properties(${EXECUTABLE_NAME} PROPERTIES PREFIX "../")
    endif(MSVC)
    INSTALL(TARGETS ${EXECUTABLE_NAME} RUNTIME DESTINATION bin)
endmacro(SETUP_EXECUTABLE EXECUTABLE_NAME)

# add include directory to all projects
include_directories(${libnova_SOURCE_DIR}/src)

# traverse the sub directories
add_subdirectory(src)
add_subdirectory(lntest)
add_subdirectory(examples)

=== examples/CMakeLists.txt ===
SETUP_EXECUTABLE(asteroid)
SETUP_EXECUTABLE(comet)
SETUP_EXECUTABLE(lunar)
SETUP_EXECUTABLE(mars)
SETUP_EXECUTABLE(sun)
SETUP_EXECUTABLE(transforms)

IF(UNIX)
  TARGET_LINK_LIBRARIES(asteroid m)
  TARGET_LINK_LIBRARIES(comet m)
  TARGET_LINK_LIBRARIES(lunar m)
  TARGET_LINK_LIBRARIES(mars m)
  TARGET_LINK_LIBRARIES(sun m)
  TARGET_LINK_LIBRARIES(transforms m)
ENDIF(UNIX)

=== lntest/CMakeLists.txt ===
SETUP_EXECUTABLE(test)

IF(UNIX)
  TARGET_LINK_LIBRARIES(test m)
ENDIF(UNIX)

=== src/CMakeLists.txt ===
set(HEADER_PATH ${libnova_SOURCE_DIR}/src/${LIBRARY_NAME})

set(LIBRARY_PUBLIC_HEADERS
	${HEADER_PATH}/julian_day.h
	${HEADER_PATH}/dynamical_time.h
	${HEADER_PATH}/sidereal_time.h
	${HEADER_PATH}/transform.h
	${HEADER_PATH}/nutation.h
	${HEADER_PATH}/libnova.h
	${HEADER_PATH}/aberration.h  
	${HEADER_PATH}/apparent_position.h
	${HEADER_PATH}/solar.h
	${HEADER_PATH}/precession.h 
	${HEADER_PATH}/proper_motion.h
	${HEADER_PATH}/mercury.h
	${HEADER_PATH}/venus.h 
	${HEADER_PATH}/earth.h 
	${HEADER_PATH}/mars.h  
	${HEADER_PATH}/jupiter.h
	${HEADER_PATH}/saturn.h 
	${HEADER_PATH}/uranus.h 
	${HEADER_PATH}/neptune.h 
	${HEADER_PATH}/pluto.h
	${HEADER_PATH}/vsop87.h
	${HEADER_PATH}/lunar.h 
	${HEADER_PATH}/elliptic_motion.h
	${HEADER_PATH}/asteroid.h
	${HEADER_PATH}/comet.h
	${HEADER_PATH}/parabolic_motion.h
	${HEADER_PATH}/refraction.h
	${HEADER_PATH}/rise_set.h
	${HEADER_PATH}/angular_separation.h
	${HEADER_PATH}/ln_types.h
	${HEADER_PATH}/utility.h
	${HEADER_PATH}/hyperbolic_motion.h
	${HEADER_PATH}/parallax.h
	${HEADER_PATH}/airmass.h
	${HEADER_PATH}/heliocentric_time.h
)

add_library(${LIBRARY_NAME} 
  ${LIBRARY_PUBLIC_HEADERS}
	julian_day.c
	dynamical_time.c
	sidereal_time.c
	transform.c
	nutation.c
	aberration.c  
	apparent_position.c
	solar.c
	precession.c 
	proper_motion.c
	mercury.c
	venus.c 
	earth.c 
	mars.c  
	jupiter.c
	saturn.c 
	uranus.c 
	neptune.c 
	pluto.c
	vsop87.c
	lunar.c 
	elliptic_motion.c
	asteroid.c
	comet.c
	parabolic_motion.c
	utility.c
	refraction.c
	rise_set.c
	angular_separation.c
	hyperbolic_motion.c
	parallax.c
	airmass.c
	heliocentric_time.c
)

if(MSVC)
    if(BUILD_SHARED_LIBRARY)
        set_target_properties(${LIBRARY_NAME} PROPERTIES PREFIX "../../bin/" IMPORT_PREFIX "../")
    else(BUILD_SHARED_LIBRARY)
        set_target_properties(${LIBRARY_NAME} PROPERTIES PREFIX "../")
    endif(BUILD_SHARED_LIBRARY)
endif(MSVC)




# install stuff
set(INSTALL_INCDIR include)
set(INSTALL_BINDIR bin)
if(WIN32)
    set(INSTALL_LIBDIR bin)
    set(INSTALL_ARCHIVEDIR lib)
else(WIN32)
    set(INSTALL_LIBDIR lib${LIB_POSTFIX})
    set(INSTALL_ARCHIVEDIR lib${LIB_POSTFIX})
endif(WIN32)

install(
    TARGETS ${LIBRARY_NAME}
    RUNTIME DESTINATION ${INSTALL_BINDIR}
    LIBRARY DESTINATION ${INSTALL_LIBDIR}
    ARCHIVE DESTINATION ${INSTALL_ARCHIVEDIR}
)

install(
    FILES       ${LIBRARY_PUBLIC_HEADERS}
    DESTINATION ${INSTALL_INCDIR}/${LIBRARY_NAME}
)

## libnova 0.14.0

=== debian/changelog ===
libnova (0.14.0-2) unstable; urgency=low

  * Team upload. Upload to unstable.

 -- Pino Toscano <pino@debian.org>  Sun, 25 Mar 2012 14:51:22 +0200

libnova (0.14.0-1) experimental; urgency=low

  * Team upload.
  * New upstream release. (Closes: #604411)

  [ Matthew Rosewarne ]
  * Add watch file.

  [ Lisandro Damián Nicanor Pérez Meyer ]
  * Bump Standards-Version to 3.9.1.
  * Add a final newline to the watch file.
  * Update installed files.

  [ José Manuel Santamaría Lema ]
  * Switch to source format 3.0 (quilt).
  * Bump debhelper compatibility level to 7.
  * Update installed files.
  * Update copyright file.
  * Don't install an uneeded *.la file. (Closes: #621545)

  [ Pino Toscano ]
  * Add Vcs-Browser and Vcs-Git headers in control.
  * Small description changes.
  * Bump Standards-Version to 3.9.3.
  * Switch from cdbs to the dh sequencer:
    - drop build dependency on cdbs
    - bump debhelper build dependency to 7.0.50~
    - run the lntest executable in a non-fatal way, as it fails and it is
      not run as a test by the build system
  * Convert to multi-arch:
    - bump debhelper build dependency to 9
    - bump compat to 9 (this also makes use of dpkg-buildflags)
    - update paths in .install files
    - mark libnova-0.14-0 as Multi-Arch: same
    - make libnova-0.14-0 pre-depend on ${misc:Pre-Depends}
  * Update date/version in libnovaconfig.1.
  * Explicitly remove .la files from debian/tmp, instead of ignore them
    in dh_install.
  * Add my contributions to the copyright file.

  [ Sune Vuorela ]
  * Change my email address to the @debian.org one.

 -- Pino Toscano <pino@debian.org>  Sun, 18 Mar 2012 10:48:52 +0100

libnova (0.12.1-1) unstable; urgency=low

  * Initial release (Closes: #453099)

 -- Sune Vuorela <debian@pusling.com>  Tue, 27 Nov 2007 13:00:34 +0100

=== debian/control ===
Source: libnova
Section: libs
Priority: optional
Maintainer: Debian Krap Maintainers <debian-qt-kde@lists.debian.org>
Build-Depends: debhelper (>= 9), autotools-dev
Standards-Version: 3.9.3
Uploaders: Sune Vuorela <sune@debian.org>
Homepage: http://libnova.sourceforge.net/
Vcs-Git: git://git.debian.org/pkg-kde/krap/libnova.git
Vcs-Browser: http://git.debian.org/?p=pkg-kde/krap/libnova.git

Package: libnova-0.14-0
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: celestial mechanics, astrometry and astrodynamics library
 libnova is a general purpose, double precision, Celestial Mechanics, 
 Astrometry and Astrodynamics library.

Package: libnova-dev
Architecture: any
Section: libdevel
Depends: libnova-0.14-0 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: development files for libnova astronomical library
 libnova is a general purpose, double precision, Celestial Mechanics, 
 Astrometry and Astrodynamics library.
 .
 This package contains the development files.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

override_dh_auto_test:
	dh_auto_test
	-lntest/lntest

override_dh_auto_install:
	dh_auto_install
	# no libtool .la files, please
	find debian/tmp -name '*.la' -type f -exec rm --verbose {} \;

override_dh_install:
	dh_install --list-missing

## libnova 0.16

=== debian/changelog ===
libnova (0.16-6) unstable; urgency=medium

  * Drop Rules-Requires-Root: no, no more needed since Debian trixie.
  * Use secure URI in Homepage field.
  * Remove inactive Uploaders, adding myself as one to avoid leaving the source
    with no human maintainers.
  * Bump Standards-Version to 4.7.2, no changes required.
  * Use execute_after_dh_auto_test & execute_after_dh_auto_install to avoid
    invoking dh_auto_test & dh_auto_install manually.
  * Remove the unused ${shlibs:Depends} substvar from libnova-dev.
  * Remove no more needed lintian overrides.
  * Drop breaks/replaces for versions older than what is in Debian Bullseye.

 -- Pino Toscano <pino@debian.org>  Sat, 25 Oct 2025 11:43:04 +0200

libnova (0.16-5.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1062485

 -- Benjamin Drung <bdrung@debian.org>  Wed, 28 Feb 2024 14:22:58 +0000

libnova (0.16-5) unstable; urgency=medium

  * Team upload.

  [ Debian Janitor ]
  * Trim trailing whitespace.
  * Bump debhelper from deprecated 9 to 12.
    + debian/rules: Rely on default use of dh_missing rather than using
      dh_install --list-missing.
  * Set debhelper-compat version in Build-Depends.
  * Set upstream metadata fields: Repository.
  * Drop unnecessary dependency on dh-autoreconf.

  [ Pino Toscano ]
  * Add the configuration for the CI on salsa.
  * Simplify install files.
  * Bump the debhelper compatibility to 13:
    - switch the debhelper-compat build dependency to 13
  * Bump Standards-Version to 4.5.0, no changes required.
  * Add Rules-Requires-Root: no.
  * Bump version of watch file to 4, and use https.
  * Drop the autotools-dev, no more needed.
  * Drop debian/libnovaconfig.1, as it was not installed; it does not provide
    any useful content anyway.
  * Rewrite copyright to copyright-format v1.0, and update.
  * Ship the upstream examples in libnova-dev.

 -- Pino Toscano <pino@debian.org>  Sun, 08 Nov 2020 09:55:47 +0100

libnova (0.16-4) unstable; urgency=medium

  * New revision
  * Fix Breaks/Replaces version (Closes: 920253)
  * Release to unstable

 -- Maximiliano Curia <maxy@debian.org>  Wed, 23 Jan 2019 09:33:25 -0300

libnova (0.16-3) unstable; urgency=medium

  [ W. Martin Borgert ]
  * Complete Multi-Arch (Closes: #873605).

  [ Maximiliano Curia ]
  * Update Vcs fields
  * Release to unstable

 -- Maximiliano Curia <maxy@debian.org>  Tue, 22 Jan 2019 10:41:53 -0300

libnova (0.16-2) unstable; urgency=medium

  * Add new patch: Use-CFLAGS-from-environment.patch.
    Thanks to Simon Ruderich for the patch (Closes: 671462)
  * Update sid version (Closes: 725775)

 -- Maximiliano Curia <maxy@debian.org>  Thu, 27 Oct 2016 10:29:14 +0200

libnova (0.16-1) experimental; urgency=medium

  * New upstream release (0.16).
  * Bump Standards-Version to 3.9.8, no changes needed.
  * Update vcs fields
  * Follow upstream soversion bump
  * Update install files
  * Update copyright information

 -- Maximiliano Curia <maxy@debian.org>  Wed, 19 Oct 2016 18:11:22 +0200

libnova (0.14.0-2.1) unstable; urgency=low

  * Non-maintainer upload.
  * Use dh-autoreconf in build to support new architectures (closes: #727419)

 -- Chen Baozi <baozich@gmail.com>  Thu, 05 Jun 2014 20:27:12 +0800

=== debian/control ===
Source: libnova
Section: libs
Priority: optional
Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 13)
Standards-Version: 4.7.2
Uploaders: Pino Toscano <pino@debian.org>,
Homepage: https://libnova.sourceforge.net/
Vcs-Browser: https://salsa.debian.org/qt-kde-team/3rdparty/libnova
Vcs-Git: https://salsa.debian.org/qt-kde-team/3rdparty/libnova.git

Package: libnova-0.16-0t64
Provides: ${t64:Provides}
Replaces: libnova-0.16-0
Breaks: libnova-0.16-0 (<< ${source:Version})
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: celestial mechanics, astrometry and astrodynamics library
 libnova is a general purpose, double precision, Celestial Mechanics,
 Astrometry and Astrodynamics library.

Package: libnova-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libnova-0.16-0t64 (= ${binary:Version}),
         libnova-dev-bin (= ${binary:Version}),
         ${misc:Depends},
Description: development files for libnova astronomical library
 libnova is a general purpose, double precision, Celestial Mechanics,
 Astrometry and Astrodynamics library.
 .
 This package contains the development files.

Package: libnova-dev-bin
Architecture: any
Multi-Arch: foreign
Section: libdevel
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: development config tool for libnova astronomical library
 libnova is a general purpose, double precision, Celestial Mechanics,
 Astrometry and Astrodynamics library.
 .
 This package contains the libnovaconfig tool.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

execute_after_dh_auto_test:
	-lntest/lntest

execute_after_dh_auto_install:
	# no libtool .la files, please
	find debian/tmp -name '*.la' -type f -exec rm --verbose {} \;

=== debian/watch ===
version=4

https://sf.net/libnova/libnova-(.*)\.tar\.gz
